#define MAX_LIST        50
char ListTbl[MAX_LIST][_MAX_LFN+1];
FIL fil;
/*------------------------------------------------------------------*/
/* Replace file name in a full path name                            */
/*------------------------------------------------------------------*/
static
void sort_by_name (
        char tbl[][_MAX_LFN+1],                // Address of the name table 
        UINT items                        // Number of items stored in the table
        )
        {
        UINT i, j, k;
        char s[_MAX_LFN+1];
        BYTE a, b;

        // Bubble sort
        for (i = 0; i + 1 < items; i++) 
                {
                for (j = i + 1; j < items; j++) 
                        {
                        for (k = 0; k < _MAX_LFN; k++) 
                                {
                                a = (BYTE)tbl[i][k];
                                b = (BYTE)tbl[j][k];
                                if (a < b) break;
                                if (a > b) 
                                        {
                                        memcpy(s, tbl[i], _MAX_LFN+1);
                                        memcpy(tbl[i], tbl[j], _MAX_LFN+1);
                                        memcpy(tbl[j], s, _MAX_LFN+1);
                                        break;
                                        }
                                }
                        }
                }
        }

static        
void sort_by_dirfile (
	char tbl[][_MAX_LFN+1],                // Address of the name table 
        UINT items                        // Number of items stored in the table
        )
        {
        UINT i, j, k;
        char s[_MAX_LFN+1];       
         
        k = items;
        for (i = 0; i < k;) 
                {
                if(tbl[i][_MAX_LFN] == AM_DIR) 
                        i++;
                else
                        {
                        for (j = i; j+1 < items; j++) 
                                {
                                memcpy(s, tbl[j], _MAX_LFN+1);
                                memcpy(tbl[j], tbl[j+1], _MAX_LFN+1);
                                memcpy(tbl[j+1], s, _MAX_LFN+1);
                                }
                        k--;
                        }
                }
        }

static
UINT get_list(char* dirname)        // Number of found albums 
        {
        UINT nlist = 0;
        DIR dir;
        FILINFO fno;
        BYTE res;
        BYTE *fn;  
        char str[10]; 
         
#if _USE_LFN
    	static char lfn[_MAX_LFN * (_DF1S ? 2 : 1) + 1];
    	fno.lfname = lfn;
    	fno.lfsize = sizeof(lfn);
#endif

        res = f_opendir(&dir, dirname);
        if (res != FR_OK)return 0;
        do
                {
                res = f_readdir(&dir, &fno);
                if (res != FR_OK || !fno.fname[0]) break;
                fn = *fno.lfname ? fno.lfname : fno.fname; 
                strcpy(ListTbl[nlist], fn);
                if (fno.fattrib & AM_DIR)
                        ListTbl[nlist][_MAX_LFN] = AM_DIR;
                else
                        ListTbl[nlist][_MAX_LFN] = 0;
                nlist++;
                } while (nlist < MAX_LIST);
        sort_by_name(ListTbl,nlist);
        sort_by_dirfile(ListTbl,nlist);
        return nlist;
        }
/*
FRESULT scan_files (char* path)
	{
    	FRESULT res;
    	FILINFO fno;
    	DIR dir;
    	int i,j=0;
    	char *fn;
        char data[48];
         
#if _USE_LFN
    	static char lfn[_MAX_LFN * (_DF1S ? 2 : 1) + 1];
    	fno.lfname = lfn;
    	fno.lfsize = sizeof(lfn);
#endif
    	res = f_opendir(&dir, path); 
         
        LCDSetFontColor(LCD_COL_BLUE);
    	if (res == FR_OK) 
        	{
        	i = strlen(path);
        	for (;;) 
                	{
            		res = f_readdir(&dir, &fno); 
            		if (res != FR_OK || fno.fname[0] == 0) break;
            		if (fno.fname[0] == '.') continue;
#if _USE_LFN
            		fn = *fno.lfname ? fno.lfname : fno.fname;
#else
            		fn = fno.fname;
#endif
            		if (fno.fattrib & AM_DIR) 
                        	{
                		sprintf(&path[i], "/%s", fn);
                                LCDPrintStr(j++,1,path,LCD_MODE_FULL);
                		res = scan_files(path);
                		if (res != FR_OK) break;
                		path[i] = 0;
            			} 
                        else 
                        	{
                		sprintf(data,"D%s/%s", path, fn); 
                                LCDPrintStr(j++,1,data,LCD_MODE_FULL);
            			}
        		}
    		}
	delay_ms(2000);
    	return res;
	}
*/