
#define SPI_ENABLE                      0x40
#define SPI_INT_ENABLE                  0x80
#define SPI_INT_DISABLE                 0x00
#define SPI_LSB_FIRST                   0x20
#define SPI_MSB_FIRST                   0x00
#define SPI_MASTER                      0x10
#define SPI_SLAVE                       0x00
#define SPI_FAL_FIRST                   0x08
#define SPI_RIS_FIRST                   0x00
#define SPI_SET_FIRST                   0x04
#define SPI_SAM_FIRST                   0x00
#define SPI_CLK_DIV4                    0x00
#define SPI_CLK_DIV16                   0x01
#define SPI_CLK_DIV64                   0x02
#define SPI_CLK_DIV128                  0x03

void SPIMasterEnable(unsigned char clk_pol,unsigned char clk_phase,unsigned char clk_div,unsigned char order,unsigned char int_enable);
void SPIMasterDisable(void);
void SPIMasterTransfer(int len, unsigned char *buf);
//unsigned char SPIIsBusy(void);

typedef enum
        {
	SPI_IDLE,
	SPI_BUSY
        } spi_status_t;

spi_status_t volatile spi_status = SPI_IDLE;
int spi_cnt;
int spi_ri;
int spi_wi;

void SPIMasterEnable(unsigned char clk_pol,unsigned char clk_phase,unsigned char clk_div,unsigned char order,unsigned char int_enable)
        {
	unsigned char spcr_buf = SPI_MASTER;
	spcr_buf |= clk_pol | clk_phase | clk_div | order | int_enable;
	SPCR = spcr_buf;

        set(MOSI_DDR,MOSI_BIT);                //MOSI = output
        set(SCK_DDR,SCK_BIT);                //SCK = output
        SPCR |= SPI_ENABLE;
        }

void SPIMasterDisable()
        {
        SPCR &= ~SPI_ENABLE;
        }


void SPIMasterTransfer(int len, unsigned char *buf)
        {
        spi_status = SPI_BUSY;
        spi_cnt = len;
        spi_wi = 0;
        spi_ri = 0;

        while (spi_wi != spi_cnt)
                {
                SPDR = buf[spi_ri];
                spi_ri++;
                loop_until_bit_is_set(SPSR,SPIF);
                buf[spi_wi] = SPDR;
                spi_wi++;
                }
        spi_status = SPI_IDLE;
        }

//unsigned char SPIIsBusy()
//        {
//        if (spi_status == SPI_IDLE) //spi_status MUST be volatile variable!!!
//                return (0);
//        else
//                return (1);
//        }


