
#define TC_CR_X                        0x92    //DFR = 0, PD = 00
#define TC_CR_Y                        0xD2    //DFR = 0, PD = 00
volatile unsigned short tc_x,tc_y;

void TCInit(void);                      //initial touch screen controller
unsigned short TCGetX(void);            //call this after TCRead() to get X value
unsigned short TCGetY(void);            //call this after TCRead() to get Y value
unsigned char TCIsPenOn(void);          //TC_PEN_PIN is 0 when the screen is pressed
void TCRead(void);                      //read analog voltage

unsigned short TCGetX(void)             //call this after TCRead() to get X value
        {
        return (tc_x);
        }
        
unsigned short TCGetY(void)             //call this after TCRead() to get Y value
        {
        return (tc_y);
        }
        
unsigned char TCIsPenOn(void)           //TC_PEN_PIN is 0 when the screen is pressed
        {        
        if (!bit_is_set(TC_PEN_PIN,TC_PEN_BIT))
                return (1); 
        return (0);
        }



void TCInit(void)
        {
        reset(SCK_PRT,SCK_BIT);
        set(MOSI_PRT,MOSI_BIT);
        reset(MISO_PRT,MISO_BIT);
        set(SD_DE_PRT,SD_DE_BIT);   
        set(SCK_DDR,SCK_BIT);
        set(MOSI_DDR,MOSI_BIT);
        reset(MISO_DDR,MISO_BIT);
        set(TC_CS_DDR,TC_CS_BIT); 

        reset(TC_PEN_DDR,TC_PEN_BIT);
        set(TC_PEN_PRT,TC_PEN_BIT);
        TCRead();                       //Wake it up
        }

void TCRead(void)                       //read analog voltage
        { 
        unsigned char spi_buf[8];
        spi_buf[0] = TC_CR_X;                 //read Y first
        spi_buf[1] = 0;                 //2nd byte is not used
        spi_buf[2] = TC_CR_Y;                 //then read X
        spi_buf[3] = 0;                 //3rd byte is not used
        spi_buf[4] = 0;                 //4th byte is not used

        SPIMasterEnable(SPI_RIS_FIRST,SPI_SAM_FIRST,SPI_CLK_DIV16,SPI_MSB_FIRST,SPI_INT_DISABLE);
         
        reset(TC_CS_PRT,TC_CS_BIT);    //clear TC_CS to 0
        SPIMasterTransfer(5,spi_buf);   //transfer data for 5 cycles
        set(TC_CS_PRT,TC_CS_BIT);      //set TC_CS to 1
        SPIMasterDisable();             //disable interrupt 

        tc_x = ((short)spi_buf[1] << 5);       //arrange received data
        tc_x |= ((short)spi_buf[2] >> 3);      //arrange received data
        tc_y = ((short)spi_buf[3] << 5);       //arrange received data
        tc_y |= ((short)spi_buf[4] >> 3);      //arrange received data 
        }